diff --git a/libr/cons/dietline.c b/libr/cons/dietline.c
index 51157e9a466..e841c5977ad 100644
--- a/libr/cons/dietline.c
+++ b/libr/cons/dietline.c
@@ -1150,10 +1150,21 @@ R_API const char *r_line_readline_cb_win(RLineReadCallback cb, void *user) {
 			if (I.sel_widget) {
 				I.sel_widget->complete_common = true;
 			}
-			r_line_autocomplete ();
+			if (I.hud) {
+				if (I.hud->top_entry_n + 1 < I.hud->current_entry_n) {
+					I.hud->top_entry_n++;
+				} else {
+					I.hud->top_entry_n = 0;
+				}
+			} else {
+				r_line_autocomplete ();
+			}
 			break;
 		/* enter */
 		case 13:
+			if (I.hud) {
+				I.hud->activate = false;
+			}
 			if (I.sel_widget) {
 				selection_widget_select ();
 				break;
@@ -1621,6 +1632,7 @@ R_API const char *r_line_readline_cb(RLineReadCallback cb, void *user) {
 	return r_line_readline_cb_win (cb, user);
 #endif
 	int columns = r_cons_get_size (NULL) - 2;
+	int rows;
 	const char *gcomp_line = "";
 	static int gcomp_idx = 0;
 	static int gcomp = 0;
@@ -1631,9 +1643,15 @@ R_API const char *r_line_readline_cb(RLineReadCallback cb, void *user) {
 	int ch, i = 0;	/* grep completion */
 	char *tmp_ed_cmd, prev = 0;
 	int prev_buflen = -1;
-
-	I.buffer.index = I.buffer.length = 0;
-	I.buffer.data[0] = '\0';
+	(void) r_cons_get_size (&rows);
+	
+	if (!I.hud || (I.hud && !I.hud->activate)) {
+		I.buffer.index = I.buffer.length = 0;
+		I.buffer.data[0] = '\0';
+		if (I.hud) {
+			I.hud->activate = true;
+		}
+	}
 	if (I.contents) {
 		memmove (I.buffer.data, I.contents,
 			R_MIN (strlen (I.contents) + 1, R_LINE_BUFSIZE - 1));
@@ -1652,9 +1670,7 @@ R_API const char *r_line_readline_cb(RLineReadCallback cb, void *user) {
 	r_cons_set_raw (1);
 
 	if (I.echo) {
-		r_cons_clear_line (0);
-		printf ("%s%s%s", Color_RESET, I.prompt, I.buffer.data);
-		fflush (stdout);
+		__print_prompt ();
 	}
 	r_cons_break_push (NULL, NULL);
 	for (;;) {
@@ -1962,7 +1978,11 @@ R_API const char *r_line_readline_cb(RLineReadCallback cb, void *user) {
 						break;
 					/* arrows */
 					case 'A':	// up arrow
-						if (I.sel_widget) {
+						if (I.hud) {
+							if (I.hud->top_entry_n + 1 < I.hud->current_entry_n) {
+								I.hud->top_entry_n++;
+							}
+						} else if (I.sel_widget) {
 							selection_widget_up (1);
 							selection_widget_draw ();
 						} else if (gcomp) {
@@ -1970,10 +1990,14 @@ R_API const char *r_line_readline_cb(RLineReadCallback cb, void *user) {
 						} else if (r_line_hist_up () == -1) {
 							r_cons_break_pop ();
 							return NULL;
-						}
+						} 
 						break;
 					case 'B':	// down arrow
-						if (I.sel_widget) {
+						if (I.hud) {
+							if (I.hud->top_entry_n >= 0) {
+								I.hud->top_entry_n--;
+							}
+						} else if (I.sel_widget) {
 							selection_widget_down (1);
 							selection_widget_draw ();
 						} else if (gcomp) {
@@ -2153,9 +2177,21 @@ R_API const char *r_line_readline_cb(RLineReadCallback cb, void *user) {
 			if (I.sel_widget) {
 				I.sel_widget->complete_common = true;
 			}
-			r_line_autocomplete ();
+			if (I.hud) {
+				if (I.hud->top_entry_n + 1 < I.hud->current_entry_n) {
+					I.hud->top_entry_n++;
+				} else {
+					I.hud->top_entry_n = 0;
+				}
+			} else {
+				r_line_autocomplete ();
+			}
 			break;
 		case 13: // enter
+			if (I.hud) {
+				I.hud->activate = false;
+				break;
+			}
 			if (I.sel_widget) {
 				selection_widget_select ();
 				break;
@@ -2263,6 +2299,9 @@ R_API const char *r_line_readline_cb(RLineReadCallback cb, void *user) {
 			}
 			fflush (stdout);
 		}
+		if (I.hud) {
+			goto _end;
+		}
 	}
 _end:
 	r_cons_break_pop ();
diff --git a/libr/cons/hud.c b/libr/cons/hud.c
index ba37e1ca25d..1181ee78bce 100644
--- a/libr/cons/hud.c
+++ b/libr/cons/hud.c
@@ -95,7 +95,6 @@ static bool __matchString(char *entry, char *filter, char *mask, const int mask_
 	return true;
 }
 
-#define HUD_BUF_SIZE 512
 
 static RList *hud_filter(RList *list, char *user_input, int top_entry_n, int *current_entry_n, char **selected_entry) {
 	RListIter *iter;
@@ -105,6 +104,8 @@ static RList *hud_filter(RList *list, char *user_input, int top_entry_n, int *cu
 	int j, rows;
 	(void) r_cons_get_size (&rows);
 	int counter = 0;
+	RLineHud *hud = (RLineHud *) R_NEW (RLineHud);
+
 	bool first_line = true;
 	RList *res = r_list_newf (free);
 	r_list_foreach (list, iter, current_entry) {
@@ -190,28 +191,33 @@ static void mht_free_kv(HtPPKv *kv) {
 #define HUD_CACHE 0
 R_API char *r_cons_hud(RList *list, const char *prompt) {
 	int ch, nch, current_entry_n, i = 0;
-	char user_input[HUD_BUF_SIZE];
+	char user_input [HUD_BUF_SIZE];
 	int top_entry_n = 0;
 	char *selected_entry = NULL;
 	RListIter *iter;
 
 	HtPP *ht = ht_pp_new (NULL, (HtPPKvFreeFunc)mht_free_kv, (HtPPCalcSizeV)strlen);
-
+	RLineHud *hud = (RLineHud*) R_NEW (RLineHud);
+	I(line)->echo = true;
+	I(line)->hud = hud;
 	user_input[0] = 0;
+	hud->top_entry_n = 0;
 	r_cons_clear ();
+	//r_cons_show_cursor (false);
 	// Repeat until the user exits the hud
 	for (;;) {
-		r_cons_gotoxy (0, 0);
-		current_entry_n = 0;
-		if (top_entry_n < 0) {
-			top_entry_n = 0;
+		hud->current_entry_n = 0;
+		
+		if (hud->top_entry_n < 0) {
+			hud->top_entry_n = 0;
 		}
 		selected_entry = NULL;
+		r_cons_visual_flush ();
 		if (prompt && *prompt) {
-			r_cons_print (">> ");
-			r_cons_println (prompt);
+			printf (">> %s\n", prompt);
 		}
-		r_cons_printf ("%d> %s|\n", top_entry_n, user_input);
+		
+		//r_cons_printf ("%d> %s|\n", hud->top_entry_n, user_input);
 		char *row;
 		RList *filtered_list = NULL;
 
@@ -219,92 +225,39 @@ R_API char *r_cons_hud(RList *list, const char *prompt) {
 		filtered_list = ht_pp_find (ht, user_input, &found);
 		if (!found) {
 			filtered_list = hud_filter (list, user_input,
-				top_entry_n, &current_entry_n, &selected_entry);
+				hud->top_entry_n, &(hud->current_entry_n), &selected_entry);
 #if HUD_CACHE
 			ht_pp_insert (ht, user_input, filtered_list);
 #endif
 		}
 		r_list_foreach (filtered_list, iter, row) {
-			r_cons_printf ("%s\n", row);
+			printf ("%s\n", row);
 		}
 #if !HUD_CACHE
 		r_list_free (filtered_list);
 #endif
-
-		r_cons_visual_flush ();
-		ch = r_cons_readchar ();
-		nch = r_cons_arrow_to_hjkl (ch);
-		int rows;
-		(void) r_cons_get_size (&rows);
-		if (nch == 'J' && ch != 'J') {
-			top_entry_n += (rows - 1);
-			if (top_entry_n + 1 >= current_entry_n) {
-				top_entry_n = current_entry_n;
-			}
-		} else if (nch == 'K' && ch != 'K') {
-			top_entry_n -= (rows - 1);
-			if (top_entry_n < 0) {
-				top_entry_n = 0;
-			}
-		} else if (nch == 'j' && ch != 'j') {
-			if (top_entry_n + 1 < current_entry_n) {
-				top_entry_n++;
-			}
-		} else if (nch == 'k' && ch != 'k') {
-			if (top_entry_n >= 0) {
-				top_entry_n--;
-			}
-		} else {
-			switch (ch) {
-			case 9:	// \t
-				if (top_entry_n + 1 < current_entry_n) {
-					top_entry_n++;
-				} else {
-					top_entry_n = 0;
-				}
-				break;
-			case 10:// \n
-			case 13:// \r
-				top_entry_n = 0;
-				// if (!*buf)
-				// return NULL;
-				if (current_entry_n >= 1) {
-					// eprintf ("%s\n", buf);
-					// i = buf[0] = 0;
+		char *pro = r_str_newf ("%d > ", hud->top_entry_n);
+		r_line_set_prompt (pro);
+		R_FREE (pro);
+		(void) r_line_readline ();
+		strcpy (user_input, I(line)->buffer.data);
+		if (!hud->activate) {
+			hud->top_entry_n = 0;
+			if (hud->current_entry_n >= 1 ) {
+				R_FREE (I(line)->hud);
+				if (selected_entry) {
 					return strdup (selected_entry);
-				}	// no match!
-				break;
-			case 23:// ^w
-				top_entry_n = 0;
-				i = user_input[0] = 0;
-				break;
-			case 0x1b:	// ESC
-				return NULL;
-			case 8:		// bs
-			case 127:	// bs
-				top_entry_n = 0;
-				if (i < 1) {
+				} else {
 					return NULL;
 				}
-				user_input[--i] = 0;
-				break;
-			default:
-				if (IS_PRINTABLE (ch)) {
-					if (i >= HUD_BUF_SIZE) {
-						break;
-					}
-					top_entry_n = 0;
-					if (i + 1 >= HUD_BUF_SIZE) {
-						// too many
-						break;
-					}
-					user_input[i++] = ch;
-					user_input[i] = 0;
-				}
-				break;
+				
 			}
+			
 		}
 	}
+	r_cons_show_cursor (true);
+	free (I(line)->contents);
+	R_FREE (I(line)->hud);
 	ht_pp_free (ht);
 	return NULL;
 }
@@ -351,7 +304,7 @@ R_API char *r_cons_message(const char *msg) {
 	int rows, cols = r_cons_get_size (&rows);
 	r_cons_clear ();
 	r_cons_gotoxy ((cols - len) / 2, rows / 2);
-	r_cons_println (msg);
+	printf ("%s\n", msg);
 	r_cons_flush ();
 	r_cons_gotoxy (0, rows - 2);
 	r_cons_any_key (NULL);
diff --git a/libr/include/r_cons.h b/libr/include/r_cons.h
index 9e35c8fc805..ede0d2404ad 100644
--- a/libr/include/r_cons.h
+++ b/libr/include/r_cons.h
@@ -432,6 +432,10 @@ typedef struct r_cons_context_t {
 	RConsPrintablePalette pal;
 } RConsContext;
 
+#define HUD_BUF_SIZE 512
+
+
+
 typedef struct r_cons_t {
 	RConsContext *context;
 	char *lastline;
@@ -970,6 +974,12 @@ typedef struct r_line_buffer_t {
 	int length;
 } RLineBuffer;
 
+typedef struct r_hud_t{
+	int current_entry_n;
+	int top_entry_n;
+	char activate;
+} RLineHud;
+
 typedef struct r_line_t RLine; // forward declaration
 typedef struct r_line_comp_t RLineCompletion;
 
@@ -1013,6 +1023,7 @@ struct r_line_t {
 	RLinePromptType prompt_type;
 	int offset_hist_index;
 	int file_hist_index;
+	RLineHud *hud;
 	RList *sdbshell_hist;
 	RListIter *sdbshell_hist_iter;
 #if __WINDOWS__
